<?php
/**
*
* @package phpBB3
* @version $Id: faq.php 1203 2008-05-09 14:30:11Z handyman $
* @copyright (c) 2008 StarTrekGuide Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

$mode = request_var('mode', '');

page_header('');

posts_anywhere(request_var('post_id', 0));

$template->set_filenames(array(
	'body' => 'posts_anywhere/viewtopic.html')
);

ob_start('posts_anywhere_buffer');

page_footer();

ob_end_clean();

function posts_anywhere_buffer($buffer)
{
	global $config;

	return str_replace('./', $config['server_protocol'] . $config['server_name'] . $config['script_path'] . '/', $buffer);
}
?>