/**
* AJAX Functions
**/
var $xmlhttp = http_object();
var $finished = 0;
var $send_queue = new Array();
var $running = false;

var $divname;
var $newform;
var $newurl;

function http_object()
{
	if (window.XMLHttpRequest)
	{
		return new XMLHttpRequest();
	}
	else if (window.ActiveXObject)
	{
		return new ActiveXObject("Microsoft.XMLHTTP");
	}
}

function send($action, $url, $form, $div, $loader)
{
	$image = '<img src="' + $loader + '" />';

	$newform = $form;
	$newurl = $url;

	switch ($action)
	{
		case 'submit':
			$send_queue.push("handle_send($newurl, $newform)");

			$divname = document.getElementById($div);
			$newdiv = document.createElement('div');
			$newdiv.setAttribute('id', 'indicator');
			$newdiv.setAttribute('style', 'margin-left: auto; margin-right: auto; width: 100%; text-align:center;');
			$newdiv.innerHTML = $image;
			$divname.appendChild($newdiv);
			$divname = $div;
		break;
		default:
			document.getElementById($div).innerHTML = '<div id="indicator" style="margin-left: auto; margin-right: auto; width: 100%; text-align:center;">' + $image + '</div>';
			$divname = $div;
			$send_queue.push("handle_send($newurl, $newform)");
		break;
	}

	if (!$running)
	{
		run_ajax();
	}

	return;
}

function run_ajax()
{
	$running = true;
	for ($i = 0; $i < $send_queue.length; $i++)
	{
		if ($xmlhttp.readyState == 4 || $xmlhttp.readyState == 0)
		{
			eval($send_queue[$i]);
		}
		else
		{
			$xmlhttp.onreadystatechange = check_state;
		}
	}
}

function check_state()
{
	if ($xmlhttp.readyState == 4 || $xmlhtt.readyState == 0)
	{
		eval($send_queue[$finished]);
	}
	else
	{
		$xmlhttp.onreadystatechange = check_state;
	}
}

function handle_send($url, $f)
{
	if ($xmlhttp.readyState == 4 || $xmlhttp.readyState == 0)
	{
		$param = '';
		if ($f)
		{
			for ($i = 0; $i < $f.elements.length; $i++)
			{
				$elem = $f.elements[$i];
				switch ($elem.type)
				{
					case 'checkbox':
					case 'radio':
						if ($elem.checked)
						{
							$param += '&' + $elem.name + '=' + encodeURIComponent($elem.value);
						}
					break;
					default:
						$param += '&' + $elem.name + '=' + encodeURIComponent($elem.value);
					break;
				}
			}
		}

		$xmlhttp.open('POST', $url, true);
		$xmlhttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		$xmlhttp.onreadystatechange = handle_return;
		$xmlhttp.send($param);
	}

	return;
}

function handle_return()
{
	if ($xmlhttp.readyState == 4)
	{
		document.getElementById($divname).innerHTML = $xmlhttp.responseText;

		$finished++;

		if ($send_queue[$finished])
		{
			check_state();
		}
		else
		{
			$send_queue = new Array();
			$finished = 0;
			$running = false;
		}
	}
	return;
}